import java.util.ArrayList;

interface NachrichtenEmpfaenger {
	// Uebergabe einer neuen Nachricht
	public void empfangeNachricht(String nachricht);
}

interface NachrichtenQuelle {

	// Interessierte knnen sich bei der Quelle anmelden
	// (falls sie noch nicht angemeldet sind)
	public void anmelden(NachrichtenEmpfaenger empf);

	// Angemeldete knnen sich bei der Quelle wieder abmelden
	// (falls sie angemeldet sind)
	public void abmelden(NachrichtenEmpfaenger empf);

	// neue Nachricht wird an alle angemeldeten
	// Empfaenger verschickt
	// (Aufruf deren Methode empfangeNachricht)
	public void sendeNachricht(String nachricht);
}

class Vermittler implements NachrichtenEmpfaenger, NachrichtenQuelle {

	ArrayList<NachrichtenEmpfaenger> empfaenger; // speichert die Empfaenger

	// Konstruktor
	public Vermittler() {
		this.empfaenger = new ArrayList<NachrichtenEmpfaenger>();
	}

	// Interessierte knnen sich bei der Quelle anmelden
	// (falls sie noch nicht angemeldet sind)
	public void anmelden(NachrichtenEmpfaenger empf) {
		if (!this.empfaenger.contains(empf)) {
			this.empfaenger.add(empf);
		}
	}

	// Angemeldete knnen sich bei der Quelle wieder abmelden
	// (falls sie angemeldet sind)
	public void abmelden(NachrichtenEmpfaenger empf) {
		if (this.empfaenger.contains(empf)) {
			this.empfaenger.remove(empf);
		}
	}

	// Uebergabe einer neuen Nachricht
	public void empfangeNachricht(String nachricht) {
		this.sendeNachricht(nachricht);
	}

	// neue Nachricht wird an alle angemeldeten
	// Empfaenger verschickt
	public void sendeNachricht(String nachricht) {
		for (int i = 0; i < this.empfaenger.size(); i++) {
			NachrichtenEmpfaenger empf = this.empfaenger.get(i);
			empf.empfangeNachricht(nachricht);
		}
	}
}

// zum Testen
public class UE20Aufgabe1 {

	public static void main(String[] args) {

	}
}
