import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Frame;
import java.awt.Label;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Vector;

// eingefgt
class ChangeListener implements StateChangeListener {

	MyFrame f;

	public ChangeListener(MyFrame f) {
		this.f = f;
	}

	public void stateHasChanged() {
		System.out.println(f.getNumberOfClicks());
	}
}

public class UE20Aufgabe10 {
	public static void main(String[] args) {
		MyFrame f = new MyFrame();
		f.setBounds(200, 200, 100, 80);
		f.setVisible(true);
		// ab hier ist der Event-Manager des AWT aktiv

		// eingefgt
		f.addStateChangeListener(new ChangeListener(f));
	}
}

interface StateChangeListener {
	public void stateHasChanged();
}

final class MyFrame extends Frame implements ActionListener,
		StateChangeListener {
	private Button button;
	private Label label;
	private int numberOfClicks;
	private Vector<StateChangeListener> listeners;

	public MyFrame() {
		super("MyFrame");
		this.numberOfClicks = 0;
		this.listeners = new Vector<StateChangeListener>();
		this.button = new Button("Please click");
		this.label = new Label("" + this.numberOfClicks);
		// fuegt Button und Label in das Fenster ein
		this.add(this.button, BorderLayout.NORTH);
		this.add(this.label, BorderLayout.SOUTH);
		this.addStateChangeListener(this);
		this.button.addActionListener(this);
	}

	// wird aufgerufen, wenn der Button geklickt wird
	public void actionPerformed(ActionEvent e) {
		this.numberOfClicks++;
		// alle Interessenten der Zustandsaenderung werden
		// informiert
		for (StateChangeListener elem : this.listeners) {
			elem.stateHasChanged();
		}
	}

	// fuegt ein Objekt ein, das Interesse daran hat,
	// ueber Zustandsaenderung der Klickanzahl informiert zu werden
	public void addStateChangeListener(StateChangeListener listener) {
		this.listeners.add(listener);
	}

	// das Fenster selbst ist auch daran interessiert,
	// ueber Zustandsaenderungen der Klickanzahl informiert zu werden;
	// falls dies passiert, wird der Text des Labels auf die aktuelle
	// Anzahl der Button-Klicks gesetzt
	public void stateHasChanged() {
		this.label.setText("" + this.numberOfClicks);
	}

	// liefert die Anzahl an Klicks auf den Button
	public int getNumberOfClicks() {
		return this.numberOfClicks;
	}
}
