
import java.awt.Button;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;

import javax.swing.JTextPane;
import javax.swing.undo.UndoManager;

public class UE20Aufgabe18 {

	public static void main(String[] args) {
		Frame window = new Frame("Mein Editor");
		window.addWindowListener(new WindowAdapter() {
			@Override
			public void windowClosing(WindowEvent e) {
				System.exit(0);
			}

		});
		window.setLayout(new GridLayout(3, 1));

		UndoManager undoManager = new UndoManager();

		JTextPane editor = new JTextPane();
		editor.getStyledDocument().addUndoableEditListener(undoManager);
		window.add(editor);

		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new GridLayout(1, 2));
		window.add(buttonPanel);

		Label message = new Label();
		window.add(message);

		Button undoButton = new Button("Undo");
		undoButton.addActionListener(new UndoListener(undoManager, message));
		buttonPanel.add(undoButton);

		Button redoButton = new Button("Redo");
		redoButton.addActionListener(new RedoListener(undoManager, message));
		buttonPanel.add(redoButton);

		window.pack();
		window.setVisible(true);
	}

}

class UndoListener implements ActionListener {

	private UndoManager undoManager;
	private Label msgLabel;

	public UndoListener(UndoManager m, Label l) {
		this.undoManager = m;
		this.msgLabel = l;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (this.undoManager.canUndo()) {
			this.undoManager.undo();
			this.msgLabel.setText("Undo ausgefhrt");
		} else {
			this.msgLabel.setText("Undo nicht mglich");
		}
	}

}

class RedoListener implements ActionListener {

	private UndoManager undoManager;
	private Label msgLabel;

	public RedoListener(UndoManager m, Label l) {
		this.undoManager = m;
		this.msgLabel = l;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (this.undoManager.canRedo()) {
			this.undoManager.redo();
			this.msgLabel.setText("Redo ausgefhrt");
		} else {
			this.msgLabel.setText("Redo nicht mglich");
		}
	}

}
