interface Vergleichbar {
	/*
	 * vergleicht das aufgerufene Objekt mit dem als Parameter uebergebenen
	 * Objekt; liefert: -1 falls das aufgerufene Objekt kleiner ist als das
	 * Parameterobjekt 0 falls beide Objekte gleich gross sind 1 falls das
	 * aufgerufene Objekt groesser ist als das Parameterobjekt
	 */
	public int vergleichenMit(Vergleichbar obj);
}

class NuetzlicheFunktionen {

	// liefert ein "kleinstes" (auf der Basis der Vergleichbar-Implementierung!)
	// Element des Parameter-Arrays
	// Achtung: Man kann davon ausgehen, dass das Parameter-Array mindestens
	// 1 Element enthaelt
	public static Vergleichbar kleinstesElement(Vergleichbar[] elemente) {
		Vergleichbar kleinstes = elemente[0];
		for (int i = 1; i < elemente.length; i++) {
			if (kleinstes.vergleichenMit(elemente[i]) == 1) {
				kleinstes = elemente[i];
			}
		}
		return kleinstes;
	}

	// liefert ein "groesstes" (auf der Basis der Vergleichbar-Implementierung!)
	// Element des Parameter-Arrays
	// Achtung: Man kann davon ausgehen, dass das Parameter-Array mindestens
	// 1 Element enthaelt
	public static Vergleichbar groesstesElement(Vergleichbar[] elemente) {
		Vergleichbar groesstes = elemente[0];
		for (int i = 1; i < elemente.length; i++) {
			if (groesstes.vergleichenMit(elemente[i]) == -1) {
				groesstes = elemente[i];
			}
		}
		return groesstes;
	}
}

class MyInteger {
	protected int wert;

	public MyInteger(int w) {
		this.wert = w;
	}

	public int getWert() {
		return this.wert;
	}
}

class VInteger extends MyInteger implements Vergleichbar {

	public VInteger(int w) {
		super(w);
	}

	public int vergleichenMit(Vergleichbar obj) {
		if (this.wert < ((VInteger) obj).wert)
			return -1;
		if (this.wert == ((VInteger) obj).wert)
			return 0;
		return 1;
	}
}

public class UE20Aufgabe2 {
	public static void main(String[] args) {
		VInteger[] array = { new VInteger(4), new VInteger(3), new VInteger(2) };
		VInteger kleinstes = (VInteger) NuetzlicheFunktionen
				.kleinstesElement(array);
		IO.println(kleinstes.getWert());
	}
}
