import java.awt.Button;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

public class UE20Aufgabe22 extends Frame {

	public static void main(String[] args) {
		new UE20Aufgabe22();
	}

	final static int BOMBE = -1;

	final int[][] feld = { { BOMBE, 1, 0, 0 }, { 2, 2, 1, 0 },
			{ 1, BOMBE, 1, 0 }, { 1, 1, 1, 0 } };

	SweeperButton[][] buttons;

	public UE20Aufgabe22() {
		super("Minesweeper");
		this.setLayout(new GridLayout(feld.length, feld[0].length));
		this.buttons = new SweeperButton[feld.length][feld[0].length];
		for (int r = 0; r < feld.length; r++) {
			for (int s = 0; s < feld[r].length; s++) {
				buttons[r][s] = new SweeperButton(feld[r][s]);
				buttons[r][s].addActionListener(new MineClickListener(
						buttons[r][s], this));
				this.add(buttons[r][s]);
			}
		}
		this.pack();
		this.setLocation(200, 300);
		this.setVisible(true);
	}

	public void checkGewonnen() {
		for (int r = 0; r < feld.length; r++) {
			for (int s = 0; s < feld[r].length; s++) {
				if (feld[r][s] != BOMBE && !buttons[r][s].istAngeklickt()) {
					return; // noch kein Ende
				}
			}
		}

		// gewonnen
		for (int r = 0; r < feld.length; r++) {
			for (int s = 0; s < feld[r].length; s++) {
				buttons[r][s].setAngeklickt();
			}
		}
	}

	public void setVerloren() {
		for (int r = 0; r < feld.length; r++) {
			for (int s = 0; s < feld[r].length; s++) {
				buttons[r][s].setEnabled(false);
			}
		}
	}

}

class SweeperButton extends Button {

	private int wert;
	private boolean angeklickt;

	public SweeperButton(int w) {
		super("" + '.');
		this.wert = w;
		this.angeklickt = false;
	}

	public boolean istBombe() {
		return this.wert == UE20Aufgabe22.BOMBE;
	}

	public boolean istAngeklickt() {
		return this.angeklickt;
	}

	public void setAngeklickt() {
		this.angeklickt = true;
		this.showWert();
	}

	private void showWert() {
		if (this.wert == UE20Aufgabe22.BOMBE) {
			this.setLabel("*");
		} else {
			this.setLabel("" + this.wert);
		}
	}
}

class MineClickListener implements ActionListener {

	private UE20Aufgabe22 spiel;
	SweeperButton button;

	public MineClickListener(SweeperButton b, UE20Aufgabe22 spiel) {
		this.button = b;
		this.spiel = spiel;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (!button.istAngeklickt()) {
			button.setAngeklickt();
			if (button.istBombe()) {
				this.spiel.setVerloren();
			} else {
				this.spiel.checkGewonnen();
			}
		}
	}

}
