interface Sequence {
	public int getNext();
}

class Naturals implements Sequence {

	int value;

	Naturals() {
		this.value = 1;
	}

	@Override
	public int getNext() {
		return this.value++;
	}
}

abstract class Filter implements Sequence {

	Sequence sequence;

	Filter(Sequence seq) {
		this.sequence = seq;
	}
}

class ZapMultiples extends Filter {

	int basicNumber;
	int value;

	ZapMultiples(int basic, Sequence seq) {
		super(seq);
		this.basicNumber = basic;
		this.calcNextValue();
	}

	@Override
	public int getNext() {
		int result = this.value;
		this.calcNextValue();
		return result;
	}

	private void calcNextValue() {
		while (true) {
			this.value = this.sequence.getNext();
			if (this.value % this.basicNumber != 0) {
				break;
			}
		}
	}
}

class Primes extends Filter {

	int value;

	Primes() {
		super(new Naturals()); // Nimm die natuerlichen Zahlen
		this.sequence.getNext(); // entferne die 1
		this.value = this.sequence.getNext(); // erste Zahl des Restes
	}

	@Override
	public int getNext() {
		int result = this.value;

		// entferne value und alle Vielfachen
		this.sequence = new ZapMultiples(this.value, this.sequence);
		this.value = this.sequence.getNext(); // erste Zahl des Restes
		return result;
	}
}

// Testprogramm (war nicht gefordert)
public class UE20Aufgabe27 {

	public static void main(String[] args) {
		Sequence s = new Primes();
		while (true) {
			System.out.println(s.getNext());
			IO.readBoolean();
		}

	}

}
