class Observable {

	private java.util.ArrayList<Observer> observers = new java.util.ArrayList<Observer>();

	public void addObserver(Observer obs) {
		observers.add(obs);
	}

	public void notifyObservers(Object info) {
		for (Observer obs : observers) {
			obs.update(info);
		}
	}
}

interface Observer {
	void update(Object info);
}

class Thermometer extends Observable {

	public void messen() {
		while (true) {
			int grad = (int) (Math.random() * 40);
			this.notifyObservers(grad);
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
			}
		}
	}

}

public class UE20Aufgabe34 {

	public static void main(String[] args) {
		Thermometer thermometer = new Thermometer();
		Schule schule = new Schule(thermometer);
		Freibad bad = new Freibad(thermometer);
		thermometer.messen();
	}

}

class Freibad implements Observer {

	boolean geschlossen;

	public Freibad(Thermometer thermometer) {
		geschlossen = true;
		thermometer.addObserver(this);
	}

	@Override
	public void update(Object arg) {
		int grad = (Integer) arg;
		if (grad < 10 && !geschlossen) {
			geschlossen = true;
			System.out.println(grad + " Grad! "
					+ "Zu kalt! Freibad wird geschlossen!");
		} else if (geschlossen && grad > 20) {
			geschlossen = false;
			System.out.println(grad + " Grad! "
					+ "Warm genug! Freibad wird geoeffnet!");
		}
	}

}

class Schule implements Observer {

	public Schule(Thermometer thermometer) {
		thermometer.addObserver(this);
	}

	@Override
	public void update(Object arg) {
		int grad = (Integer) arg;
		if (grad > 28) {
			System.out.println(grad + " Grad! " + "Schule gibt Hitzefrei!");
		}
	}

}
