
import java.util.Iterator;

class Element39 {
	int value; // Speicher fuer einen Wert
	Element39 next; // Referenz auf das folgende Element (oder null fuer Ende)

	Element39(int v, Element39 n) {
		this.value = v;
		this.next = n;
	}
}

class List39 implements Iterable<Integer> {
	Element39 first; // erstes Element der Liste
	Element39 last; // letztes Element der Liste

	List39() {
		this.first = null;
		this.last = null;
	}

	void append(int i) {
		Element39 elem = new Element39(i, null);
		if (this.first == null) { // erstes Element in der Liste
			this.first = elem;
			this.last = elem;
		} else { // Anhaengen des Elementes am Ende
			this.last.next = elem;
			this.last = elem;
		}
	}

	@Override
	public Iterator<Integer> iterator() {
		return new List39Iterator(this.first);
	}
}

class UE20Aufgabe39 {

	public static void main(String[] args) {
		List39 list = new List39();
		list.append(8);
		list.append(6);
		list.append(2);
		list.append(3);
		list.append(7);
		list.append(1);
		list.append(2);

		Iterator<Integer> it = list.iterator();
		while (it.hasNext()) {
			System.out.print(it.next() + " -> ");
		}
		System.out.println();

		for (Integer i : list) {
			System.out.print(i + " -> ");
		}
	}
}

class List39Iterator implements Iterator<Integer> {

	Element39 elem;

	List39Iterator(Element39 first) {
		elem = first;
	}

	@Override
	public boolean hasNext() {
		return elem != null;
	}

	@Override
	public Integer next() {
		if (elem == null) {
			return null;
		}
		int result = elem.value;
		elem = elem.next;
		return result;
	}

}
