
// Achtung: Kein guter Quellcode; nur eine Quick-and-Dirty-Musterloesung!!!!!!
import java.awt.Button;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JFrame;

// http://flashgamehq.com/flash-game/twinballs
public class UE20Aufgabe43 {

	public static void main(String[] args) {
		char[][] spielfeld = IO.readFileAsCharMatrix("TwinBallsFeld.txt");
		int reihen = spielfeld.length;
		int spalten = spielfeld[0].length;
		JFrame fenster = new JFrame("TwinBalls");
		fenster.setLayout(new GridLayout(3, 1));
		fenster.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		Panel buttonPanel = new Panel();
		buttonPanel.setLayout(new GridLayout(reihen, spalten));
		Button[][] buttons = new Button[reihen][spalten];
		for (int r = 0; r < reihen; r++) {
			for (int s = 0; s < spalten; s++) {
				buttons[r][s] = new Button("" + spielfeld[r][s]);
				buttonPanel.add(buttons[r][s]);
			}
		}
		Spiel spiel = new Spiel(spielfeld, buttons);
		fenster.add(buttonPanel);
		Panel steuerPanel = new Panel();
		steuerPanel.setLayout(new GridLayout(1, 4));
		Button linksButton = new Button("<");
		steuerPanel.add(linksButton);
		Button rechtsButton = new Button(">");
		steuerPanel.add(rechtsButton);
		Button obenButton = new Button("^");
		steuerPanel.add(obenButton);
		Button untenButton = new Button("v");
		steuerPanel.add(untenButton);
		fenster.add(steuerPanel);
		Label nachrichtenLabel = new Label("Spiel hat begonnen");
		fenster.add(nachrichtenLabel);

		linksButton.addActionListener(new LinksListener(spiel, nachrichtenLabel));
		rechtsButton.addActionListener(new RechtsListener(spiel, nachrichtenLabel));
		obenButton.addActionListener(new ObenListener(spiel, nachrichtenLabel));
		untenButton.addActionListener(new UntenListener(spiel, nachrichtenLabel));

		fenster.setBounds(100, 100, 400, 600);
		fenster.setVisible(true);
	}
}

class MoveListener {

	protected Spiel spiel;
	protected Label nachrichtenLabel;

	MoveListener(Spiel s, Label nachrichtenLabel) {
		this.spiel = s;
		this.nachrichtenLabel = nachrichtenLabel;
	}

	public void check() {
		if (spiel.hatGewonnen()) {
			this.nachrichtenLabel.setText("Gewonnen!");
		} else if (spiel.hatVerloren()) {
			this.nachrichtenLabel.setText("Leider verloren!");
		}
	}

}

class LinksListener extends MoveListener implements ActionListener {

	LinksListener(Spiel s, Label nachrichtenLabel) {
		super(s, nachrichtenLabel);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		spiel.verschiebeBaelle(-1, 0);
		check();
	}

}

class RechtsListener extends MoveListener implements ActionListener {

	RechtsListener(Spiel s, Label nachrichtenLabel) {
		super(s, nachrichtenLabel);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		spiel.verschiebeBaelle(1, 0);
		check();
	}

}

class ObenListener extends MoveListener implements ActionListener {

	ObenListener(Spiel s, Label nachrichtenLabel) {
		super(s, nachrichtenLabel);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		spiel.verschiebeBaelle(0, -1);
		check();
	}

}

class UntenListener extends MoveListener implements ActionListener {

	UntenListener(Spiel s, Label nachrichtenLabel) {
		super(s, nachrichtenLabel);
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		spiel.verschiebeBaelle(0, 1);
		check();
	}

}

class Ball {
	private int reihe;
	private int spalte;

	public Ball(int reihe, int spalte) {
		super();
		this.reihe = reihe;
		this.spalte = spalte;
	}

	public int getReihe() {
		return reihe;
	}

	public int getSpalte() {
		return spalte;
	}

	public void setReihe(int reihe) {
		this.reihe = reihe;
	}

	public void setSpalte(int spalte) {
		this.spalte = spalte;
	}
}

class Spiel {
	private char[][] feld;
	private Button[][] buttons;
	private Ball[] baelle;
	private int reihen;
	private int spalten;
	private boolean verloren;
	private boolean gewonnen;

	public Spiel(char[][] feld, Button[][] buttons) {
		this.feld = feld;
		this.buttons = buttons;
		this.reihen = buttons.length;
		this.spalten = buttons[0].length;
		baelle = new Ball[2];
		int n = 0;
		for (int r = 0; r < reihen; r++) {
			for (int s = 0; s < spalten; s++) {
				if (feld[r][s] == 'B') {
					baelle[n++] = new Ball(r, s);
				}
			}
		}
		verloren = false;
		gewonnen = false;
	}

	public boolean isEnde() {
		return verloren || gewonnen;
	}

	public boolean hatGewonnen() {
		return gewonnen;
	}

	public boolean hatVerloren() {
		return verloren;
	}

	public void verschiebeBaelle(int hori, int verti) {
		if (isEnde()) {
			return;
		}
		for (int b = 0; b < baelle.length; b++) {
			if (baelle[b].getSpalte() + hori < 0 || baelle[b].getSpalte() + hori >= spalten
					|| this.feld[baelle[b].getReihe()][baelle[b].getSpalte() + hori] == 'X') {
				verloren = true;
				return;
			}
			if (baelle[b].getReihe() + verti < 0 || baelle[b].getReihe() + verti >= reihen
					|| this.feld[baelle[b].getReihe() + verti][baelle[b].getSpalte()] == 'X') {
				verloren = true;
				return;
			}
		}
		int n = 0;
		for (int b = 0; b < baelle.length; b++) {
			if (feld[baelle[b].getReihe() + verti][baelle[b].getSpalte() + hori] == '#') {
				continue;
			}
			if (buttons[baelle[b].getReihe() + verti][baelle[b].getSpalte() + hori].getLabel().equals("O")) {
				n++;
			}
			feld[baelle[b].getReihe()][baelle[b].getSpalte()] = ' ';
			baelle[b].setReihe(baelle[b].getReihe() + verti);
			baelle[b].setSpalte(baelle[b].getSpalte() + hori);
			feld[baelle[b].getReihe()][baelle[b].getSpalte()] = 'B';
		}
		if (n == baelle.length) {
			gewonnen = true;
		} else if (n > 0) {
			verloren = true;
			return;
		}
		for (int r = 0; r < reihen; r++) {
			for (int s = 0; s < spalten; s++) {
				buttons[r][s].setLabel("" + feld[r][s]);
			}
		}

	}
}
